﻿Imports Infragistics.Web.UI.GridControls
Imports System.Data

Partial Class _Default
    Inherits System.Web.UI.Page

    Dim WithEvents wdg As WebDataGrid
    Dim dtprovider As DatePickerProvider = Nothing

    Protected Sub Page_Load(ByVal Sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        BuildWebDataGrid()
        BuildDatePickerProvider(False, "DateOfHire")    ' Comment this line out to see how PreRender occurs too late in the ASP.NET Page LifeCycle
    End Sub

    Protected Sub Page_PreRender(ByVal Sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        If dtprovider Is Nothing Then
            BuildDatePickerProvider(False, "DateOfHire")
        End If
    End Sub

    Protected Sub BuildWebDataGrid()
        wdg = New WebDataGrid()
        wdg.ID = "wdg"
        wdg.Height = Unit.Pixel(350)
        wdg.Width = Unit.Pixel(400)
        wdg.AutoGenerateColumns = False

        Dim bdf As BoundDataField = New BoundDataField()
        bdf.Key = "EmployeeID"
        bdf.Hidden = True
        bdf.Header.Text = "EmployeeID"
        wdg.Columns.Add(bdf)

        bdf = New BoundDataField()
        bdf.Key = "Name"
        bdf.Header.Text = "Name"
        wdg.Columns.Add(bdf)

        bdf = New BoundDataField()
        bdf.Key = "OnSite"
        bdf.Header.Text = "OnSite"
        wdg.Columns.Add(bdf)

        bdf = New BoundDataField()
        bdf.Key = "DateOfHire"
        bdf.Header.Text = "DateOfHire"
        wdg.Columns.Add(bdf)

        bdf = New BoundDataField()
        bdf.Key = "Department"
        bdf.Header.Text = "Department"
        wdg.Columns.Add(bdf)

        wdg.Behaviors.CreateBehavior(Of Infragistics.Web.UI.GridControls.EditingCore)()
        wdg.Behaviors.EditingCore.Behaviors.CreateBehavior(Of Infragistics.Web.UI.GridControls.CellEditing)()
        wdg.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.MouseClick = Infragistics.Web.UI.GridControls.EditMouseClickAction.Single

        UpdatePanel1.ContentTemplateContainer.Controls.Add(wdg)

        wdg.DataSource = GetEmployees()
    End Sub

    Protected Sub BuildDatePickerProvider(ByVal required As Boolean, ByVal columnName As String)
        dtprovider = New DatePickerProvider()
        dtprovider.ID = "date_" & columnName
        dtprovider.EditorControl.OpenCalendarOnFocus = True
        'dtprovider.EditorControl.EnableEmbeddedJavaScript = True
        wdg.EditorProviders.Add(dtprovider)
        Dim columnSetting As EditingColumnSetting = New EditingColumnSetting()
        'Dim rowSetting As RowAddingColumnSetting = New RowAddingColumnSetting()
        columnSetting.ColumnKey = columnName
        columnSetting.EditorID = dtprovider.ID
        'rowSetting.ColumnKey = columnName
        'rowSetting.EditorID = dtprovider.ID
        'rowSetting.DefaultValue = Date.Now()
        'If required Then
        '    Dim validator As New AJAXWorkaround.RequiredFieldValidator()
        '    validator.ID = "validator_" & columnName
        '    validator.ErrorMessage = "Input is required for this field!"
        '    validator.ControlToValidate = Me.ID
        '    Me.Controls.Add(validator)
        '    columnSetting.ValidatorID = validator.ID
        '    rowSetting.ValidatorID = validator.ID
        '    Me.Parent.Controls.Add(validator)
        'End If
        wdg.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(columnSetting)
        'Behaviors.EditingCore.Behaviors.RowAdding.ColumnSettings.Add(rowSetting)
    End Sub

#Region "TestData"
    Private Function GetEmployees(Optional ByVal count As Integer = 23) As DataTable
        Dim dtData As DataTable = New DataTable("Employees")

        dtData.Columns.Add("EmployeeID", GetType(Integer))
        dtData.Columns.Add("Name", GetType(String))
        dtData.Columns.Add("OnSite", GetType(Boolean))
        dtData.Columns.Add("DateOfHire", GetType(DateTime))
        dtData.Columns.Add("Department", GetType(Integer))

        For i As Integer = 0 To count Step 1
            dtData.Rows.Add(New Object() {i, String.Format("Name {0}", i), (i Mod 2 = 0), DateTime.Today, i Mod 8})
        Next

        dtData.PrimaryKey = New DataColumn() {dtData.Columns("EmployeeID")}

        Return dtData
    End Function
#End Region
End Class
